unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, UsbUnit;

type
  TForm1 = class(TForm)
    Button1: TButton;
    StatusBar1: TStatusBar;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
  private
    haveUSB : integer;
    USBhandle : pusb_dev_handle;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

const
        (* USB Request-Commands *)
        PSCMD_CALL_ECHO	 =	0;
        PSCMD_CALL_GETSTATUS =	1;

        (* USB Response-Codes *)
        PSCMD_RETN_OKAY	  =	($0);
        PSCMD_RETN_BUSY	  =	($1);
        PSCMD_RETN_UNKNOW	= ($ff);


{$R *.dfm}

function myconvert(var buffer : array of char) : String;
var i : integer;
begin
  i:=0;
  result:='';
  while (ord(buffer[i]) <> 0) do
    begin
      result:=result+buffer[i];
      inc(i);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
      i : integer;
      data : array[0..255] of byte;
      hmm : int64;

begin
  if (self.haveUSB = 0) then
    begin
      i:=usb_control_msg(self.USBhandle, USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, PSCMD_CALL_GETSTATUS, 0, 0, data, sizeof(data), 5000);

      if (i>=8) then
        begin
         hmm:=0;
         for i:=7 downto 3 do hmm:=(hmm shl 8) or data[i];
         Memo1.Lines.Add('jiffies='+inttostr(hmm));
        end;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 randomize;
 usb_init;
 self.haveUSB := usbOpenDevice(self.USBhandle, $16C0, $05DC, 'www.matrixstorm.com', 'USB<->PC', 'template');
 if (self.haveUSB <> 0) then Memo1.Lines.Add('usbOpenDevice error');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if (self.haveUSB = 0) then usb_close(self.USBhandle);
 self.USBhandle:=NIL;
 self.haveUSB:=USB_ERROR_NOTFOUND;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
      j, i, v : integer;
      okay : boolean;
      data : array[0..255] of byte;

begin
  if (self.haveUSB = 0) then
    begin
      okay:=true;
      for j:=0 to 1000 do
      begin
        v:=random(65535);
        i:= usb_control_msg(self.USBhandle, USB_TYPE_VENDOR or USB_RECIP_DEVICE or USB_ENDPOINT_IN, PSCMD_CALL_ECHO, v, 0, data, sizeof(data), 5000);
        if (i>=4) then
          begin
            if (data[0]=PSCMD_CALL_ECHO) then
              begin
               if (data[1]=PSCMD_RETN_OKAY) then
                begin
                 i:=(data[3] shl 8) or data[2];
                 if (i<>v) then okay:=false;
                end else okay:=false;
              end else okay:=false;
          end else okay:=false;
          if (not(okay)) then break;
      end;
      if (okay) then Memo1.Lines.Add('test successful')
      else Memo1.Lines.Add('test FAILED');
    end;
end;

end.
